string StringFromBuffer(MemoryBuffer@ buf) {
    uint32 len = uint32FromBuffer(buf);
    string s = buf.ReadString(len);
    return s;
}

void stringToBuffer(MemoryBuffer@ buf, const string &in s) {
    buf.Write(uint32(s.Length));
    buf.Write(s);
}

uint64 uint64FromBuffer(MemoryBuffer@ buf) {
    return buf.ReadUInt64();
}

uint32 uint32FromBuffer(MemoryBuffer@ buf) {
    return buf.ReadUInt32();
}

uint16 uint16FromBuffer(MemoryBuffer@ buf) {
    return buf.ReadUInt16();
}

void uint64ArrayToBuffer(MemoryBuffer@ buf, uint64[] arr) {
    uint16 len = arr.Length;
    buf.Write(len);
    for (uint i = 0; i < len; i++) {
        buf.Write(arr[i]);
    }
}

uint64[] uint64ArrayFromBuffer(MemoryBuffer@ buf) {
    uint16 len = uint16FromBuffer(buf);
    uint64[] arr(len);
    for (uint i = 0; i < len; i++) {
        arr[i] = uint64FromBuffer(buf);
    }
    return arr;
}