class mapsLoader {
    uint LiveIt = 0, LiveIt2 = 0;
    uint CoreIt = 0, CoreIt2 = 0;
    uint RecordIt = 0, RecordIt2 = 0;
    dictionary@ dLive, dCore, dRecord, dMaps;
    string[] waitingLive = {}, waitingCore = {}, waitingRecord = {};
    uint maxSizeLive = 90, maxSizeCore = 200, maxSizeRecord = 200;
    uint time;
    uint lCoreTime, lLiveTime, lRecordTime;
    bool loadCore = false, loadLive = false, loadRecord = false;
    uint maxTimeSinceLoadLive = 500, maxTimeSinceLoadCore = 500, maxTimeSinceRecord = 500;

    mapsLoader() {
        @dLive = dictionary();
        @dCore = dictionary();
        @dRecord = dictionary();
        @dMaps = dictionary();
        time = Time::Now;
        lCoreTime = time;
        lLiveTime = time;
        lRecordTime = time;
    }

    void startUp() {
        startnew(CoroutineFunc(handler));
    }

    void quickLoadBatch(const string &in uid, campaignInfo@ ci, bool forceLoad = false) {
        startnew(CoroutineFuncUserdata(this.loadBatchMap), mapsLoader::loadBatch::input(uid, ci, forceLoad));
    }

    mapInfo@ quickGetMap(const string &in uid) {
        while (!dMaps.Exists(uid)) yield();
        mapInfo@ mi = cast<mapInfo>(dMaps[uid]);
        dMaps.Delete(uid);
        return mi;
    }

    void loadBatchMap(ref@ thing) {
        mapsLoader::loadBatch::input@ inp = cast<mapsLoader::loadBatch::input>(thing);
        string mapUid = inp.mapUid;
        campaignInfo@ ci = inp.ci;
        bool forceLoad = inp.forceLoad;

        uint coreIt = addMapCore(mapUid, forceLoad);
        auto oCore = getCoreMap(mapUid, coreIt);
        if (!oCore.exist) return;
        Json::Value jsonCore = oCore.json;
        string trackId = jsonCore["mapId"];
        string campaignId = ci.campaignId;
        string name = jsonCore["name"];
        string author = jsonCore["author"];
        string fileUrl = jsonCore["fileUrl"];
        uint64[] medals = {jsonCore["authorScore"], jsonCore["goldScore"], jsonCore["silverScore"], jsonCore["bronzeScore"]};
        uint64 time = 0;
        Json::Value recordJson = nadeoCoreAPIReq("https://prod.trackmania.core.nadeo.online/v2/mapRecords/?accountIdList="+accountId+"&mapId="+trackId);
        if (recordJson.GetType() == Json::Type::Array && recordJson.Length == 1) {
            time = recordJson[0]["recordScore"]["time"];
        }

        mapInfo@ mi = mapInfo(trackId, mapUid, campaignId, name, author, fileUrl, medals, time);
        @dMaps[mapUid] = mi;
    }
    

    void handler() {
        while (true) {
            time = Time::Now;
            if (waitingCore.Length == 0) lCoreTime = time;
            if (waitingLive.Length == 0) lLiveTime = time;
            if (waitingRecord.Length == 0) lRecordTime = time;

            if (loadCore || time - lCoreTime > maxTimeSinceLoadCore || waitingCore.Length >= maxSizeCore) {
                loadMapsCore();
                if (develepor) trace("calling api (loadMapsCore)");
                lCoreTime = time;
                loadCore = false;
                yield();
            }

            if (loadLive || time - lLiveTime > maxTimeSinceLoadLive || waitingLive.Length >= maxSizeLive) {
                loadMapsLive();
                if (develepor) trace("calling api (loadMapsLive)");
                lLiveTime = time;
                loadLive = false;
            }
            
            yield();
        }
    }

    uint addMapCore(const string &in uid, bool forceLoad = false) {
        waitingCore.InsertLast(uid);
        loadCore = forceLoad || loadCore;
        return CoreIt2;
    }

    uint addMapLive(const string &in uid, bool forceLoad = false) {
        waitingLive.InsertLast(uid);
        loadLive = forceLoad || loadLive;
        return LiveIt2;
    }


    void loadMapsLive() {
        LiveIt2++;
        string[] temp = waitingLive;
        waitingLive = {};
        for (uint j = 0; j < temp.Length; j += 100) {
            string uids = temp[j];
            for (int i = j+1; i < Math::Min(temp.Length, j+100); i++) {
                uids += "," + temp[i];
            }

            Json::Value json = nadeoAPIReq("https://live-services.trackmania.nadeo.live/api/token/map/get-multiple?mapUidList=" + uids)["mapList"];

            for (uint i = 0; i < json.Length; i++) {
                @dLive[json[i]["uid"]] = json[i];
            }
        }

        LiveIt++;
        temp = {};
    }

    void loadMapsCore() {
        CoreIt2++;
        string[] temp = waitingCore;
        waitingCore = {};
        for (uint j = 0; j < temp.Length; j += 250) {
            string uids = temp[j];
            for (int i = j+1; i < Math::Min(temp.Length, j+250); i++) {
                uids += "," + temp[i];
            }

            Json::Value@ json = nadeoCoreAPIReq("https://prod.trackmania.core.nadeo.online/maps/?mapUidList=" + uids);
            if(json.GetType() != Json::Type::Array) {
                warn("Bad api req, api req size : " + ("https://prod.trackmania.core.nadeo.online/maps/?mapUidList=" + uids).Length);
                continue;
            }

            for (uint i = 0; i < json.Length; i++) {
                @dCore[json[i]["mapUid"]] = json[i];
            }
        }

        temp = {};
        CoreIt++;
    }


    mapsLoader::outputPair getLiveMap(const string &in uid, uint it) {
        while (it >= LiveIt) yield();
        if (!dLive.Exists(uid)) return mapsLoader::outputPair(false, Json::Object());
        Json::Value@ json = cast<Json::Value>(dLive[uid]);
        dLive.Delete(uid);
        return mapsLoader::outputPair(true, json);
    }

    mapsLoader::outputPair getCoreMap(const string &in uid, uint it) {
        while (it >= CoreIt) yield();
        if (!dCore.Exists(uid)) return mapsLoader::outputPair(false, Json::Object());
        Json::Value@ json = cast<Json::Value>(dCore[uid]);
        dCore.Delete(uid);
        return mapsLoader::outputPair(true, json);
    }
}

namespace mapsLoader {
    class outputPair {
        bool exist = false;
        Json::Value json = Json::Object();

        outputPair(bool _exist, Json::Value _json) {
            exist = _exist;
            json = _json;
        }
    }
    
    namespace loadBatch {
        class input {
            string mapUid;
            campaignInfo@ ci = campaignInfo("", "");
            bool forceLoad = false;

            input(string _mapUid, campaignInfo@ _ci, bool _forceLoad = false) {
                mapUid = _mapUid;
                ci = _ci;
                forceLoad = _forceLoad;
            }
        }
    }
}

